/***********************************************
*  FreeRTOS Test Program sample6
*  Mutex Semaphore Control
***********************************************/
#include <p32xxxx.h>
#include "FreeRTOS.h" 					/* FreeRTOSwb_ */
#include "queue.h"
#include "semphr.h"

/***  RtBM[Vݒ  ***/
//CPU=80MHz Peri=80MHz, HS+PLL, Divider=1/2, PLL=20x, WDT=Off
#pragma config FNOSC = PRIPLL, POSCMOD = HS, FPLLIDIV = DIV_2
#pragma config FPLLMUL = MUL_20, FPBDIV = DIV_1, FPLLODIV = DIV_1
#pragma config FWDTEN = OFF, OSCIOFNC = ON, ICESEL = ICS_PGx2
/* 萔` */
#define SYS_FREQ	80000000				// Fcy
#define BAUD 		9600					// UART Baud Rate
/* ϐ`*/
xSemaphoreHandle Mutex;
/* ֐vg */
void vTask1( void *pvParameters );			// ^XNP
void vTask2( void *pvParameters );			// ^XNQ
void itostring(char digit, unsigned int data, char *buffer);

/****************** C֐ ************************/
int main(void){
	/* VXeݒ */
	SYSTEMConfigPerformance(SYS_FREQ);		// VXeő
	mJTAGPortEnable(DEBUG_JTAGPORT_OFF);	// JTAG𖳌
	LATA = 0; 							// LEDݒ
	TRISA = 0;

	/* Open UART2 with Receive and Transmitter enable  */
	OpenUART2(UART_EN, UART_RX_ENABLE | UART_TX_ENABLE, SYS_FREQ/16/BAUD-1);
	printf("\r\n*** FreeRTOS Test Program No6 ***\r\n");
	/* 荞݋ */
	INTEnableSystemMultiVectoredInt();
	/* rZ}tH@*/
	Mutex = xSemaphoreCreateMutex();
	if(Mutex != NULL){
		/* ^XN  */
		xTaskCreate( vTask1, "Task1", 100, NULL, 1, NULL );
		xTaskCreate( vTask2, "Task2", 100, NULL, 1, NULL );
		/* XPW[OJn@*/
		vTaskStartScheduler();
	}
	/********@C[v  *******/
	while(1)
	{	}
}

/***** ^XN1֐ ******/
void vTask1(void *pvParameters){
	static unsigned char Msg1[] = "Task1 Count = xxxxx\r\n";
	static unsigned int Count1 = 0;

	while(1)	{	// 0.4bŌJԂ
		LATA ^= 0x80;							// LED_
		itostring(5, Count1, Msg1+14);			// bZ[Wp
		// \[XmۂĂo
		xSemaphoreTake(Mutex, portMAX_DELAY);		
		printf(Msg1);
		Count1++;
		xSemaphoreGive(Mutex);					// \[X
		vTaskDelay( 400 / portTICK_RATE_MS );
	}
}
/***** ^XN2֐ ******/
void vTask2(void *pvParameters){
	static unsigned char Msg2[] = "Task2 Count = xxxxx\r\n";
	static unsigned int Count2 = 0;

	while(1)	{	// 0.2bŌJԂ
		LATA ^= 0x40;							// LED_
		itostring(5, Count2, Msg2+14);			// bZ[Wp
		xSemaphoreTake(Mutex, portMAX_DELAY);
		printf(Msg2);
		Count2++;
		xSemaphoreGive(Mutex);
		vTaskDelay( 200 / portTICK_RATE_MS );
	}
}

/*****************************************
*   l當ɕϊ
*****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;

	buffer += digit;						//̍Ō
	for(i=digit; i>0; i--) {				//ŉʌʂ
		buffer--;						//|C^[P
		*buffer = (data % 10) + '0';		//̌l𕶎ɂĊi[
		data = data / 10;					//-1
	}
}
